import { BaseRequestOptions, BaseService, PaginatedRequestOptions, Sudo } from '../infrastructure';
interface CommitAction {
    /** The action to perform */
    action: 'create' | 'delete' | 'move' | 'update';
    /** Full path to the file. Ex. lib/class.rb */
    filePath: string;
    /** Original full path to the file being moved.Ex.lib / class1.rb */
    previousPath?: string;
    /** File content, required for all except delete. Optional for move */
    content?: string;
    /** text or base64. text is default. */
    encoding?: string;
    /** Last known file commit id. Will be only considered in update, move and delete actions. */
    lastCommitId?: string;
}
export declare class Commits extends BaseService {
    all(projectId: string | number, options?: PaginatedRequestOptions): Promise<import("../infrastructure").GetResponse>;
    cherryPick(projectId: string | number, sha: string, branch: string, options?: Sudo): Promise<object>;
    comments(projectId: string | number, sha: string, options?: Sudo): Promise<import("../infrastructure").GetResponse>;
    create(projectId: string | number, branch: string, message: string, actions?: CommitAction[], options?: BaseRequestOptions): Promise<object>;
    createComment(projectId: string | number, sha: string, note: string, options?: BaseRequestOptions): Promise<object>;
    diff(projectId: string | number, sha: string, options?: Sudo): Promise<import("../infrastructure").GetResponse>;
    editStatus(projectId: string | number, sha: string, options?: BaseRequestOptions): Promise<object>;
    references(projectId: string | number, sha: string, options?: Sudo): Promise<import("../infrastructure").GetResponse>;
    show(projectId: string | number, sha: string, options?: BaseRequestOptions): Promise<import("../infrastructure").GetResponse>;
    status(projectId: string | number, sha: string, options?: BaseRequestOptions): Promise<import("../infrastructure").GetResponse>;
    mergeRequests(projectId: string | number, sha: string, options?: BaseRequestOptions): Promise<import("../infrastructure").GetResponse>;
}
export {};
